/* ***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1/LGPL 2.1/GPL 2.0

The contents of this file are subject to the Mozilla Public License Version 
1.1 (the "License"); you may not use this file except in compliance with
...
for the specific language governing rights and limitations under the
License.

The Original Code is for Luminous Forts.

The Initial Developer of the Original Code is Hekar Khani.
Portions created by the Hekar Khani are Copyright (C) 2010
Hekar Khani. All Rights Reserved.

Contributor(s):
  Hekar Khani <hekark@gmail.com>

Alternatively, the contents of this file may be used under the terms of
either of the GNU General Public License Version 2 or later (the "GPL"),
...
the terms of any one of the MPL, the GPL or the LGPL.

***** END LICENSE BLOCK ***** */

#ifndef MOD_LUA
#error Lua_Main may only be included if Lua compilation is enabled (MOD_LUA)
#endif // MOD_LUA

#ifndef LUA_MAIN_H
#define LUA_MAIN_H

#ifdef WIN32
#pragma once
#endif

// We're not using std::, so 
// ignore these warnings (they're not linked in either)
#pragma warning( disable : 4251 )
#pragma warning( disable : 4275 )

extern "C"
{
    #include "lua.h"
}
#include "luabind/luabind.hpp"
#include <luabind/function.hpp>
#include <luabind/class.hpp>

class CLuaManager
{
public:
	CLuaManager();
	~CLuaManager();

	lua_State *GetState() { return m_State; }

	void ExecuteString( const char *code );
	void ExecuteFile( const char *filename );

private:
	lua_State *m_State;
};

extern void InitLuaManager();
extern CLuaManager *LuaManager();

#define BEGIN_LUA \
	class Lua_Register : public CAutoGameSystem { \
	public: \
	Lua_Register() { } \
	void PostInit() {

#define END_LUA \
	} }; \
	static Lua_Register g_Lua_Register_Static;

#endif // LUA_MAIN_H